// 4x4 Magic Square Calculator by Daniel Marschall
// Version 4.5
// Vorgehen: Wie bei Version 5, nur mit manueller Permutation. Langsam!
// Deshalb ist die GSL-Fassung weiterentwickelt worden.

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
     
const char * MERGE_FILE = "Complete.txt";
const char * RES_LINE = "4x4 (%d) = %d %d %d %d | %d %d %d %d | %d %d %d %d | %d %d %d %d %c\n";

bool wipe_file(const char * filename) {
	FILE *out;
	if (out = fopen(filename, "w")) {
		fclose(out);
		return true;
	} else return false;
}

bool write_result(size_t *data) {
	char buffer[255];

	int sum = data[0]+data[1]+data[2]+data[3];
	char bonus = (sum == data[12]+data[9]+data[6]+data[3]) ? '*' : ' ';

	FILE *out;
	if (out = fopen(MERGE_FILE, "a")) {
		sprintf(buffer, RES_LINE, sum+4, data[0]+1, data[1]+1, data[2]+1, data[3]+1, data[4]+1, data[5]+1, data[6]+1, data[7]+1, data[8]+1, data[9]+1, data[10]+1, data[11]+1, data[12]+1, data[13]+1, data[14]+1, data[15]+1, bonus);

		int res = fputs(buffer, out);
		fclose(out);

		return res >= 0;
	} else return false;
}

bool begin() {
	char buffer[255];

	FILE *out;
	if (out = fopen(MERGE_FILE, "a")) {
		sprintf(buffer, "Beginning!\n");

		int res = fputs(buffer, out);
		fclose(out);

		return res >= 0;
	} else return false;
}

bool finish() {
	char buffer[255];

	FILE *out;
	if (out = fopen(MERGE_FILE, "a")) {
		sprintf(buffer, "Finished!\n");

		int res = fputs(buffer, out);
		fclose(out);

		return res >= 0;
	} else return false;
}

const int NUM_ELEMENTS = 16;

/* bool nextperm(int* p) {
	int i,j,swap;

	for (i=NUM_ELEMENTS-2; i>=0; i--) if(p[i]<p[i+1]) break;
	if(i<0) return false;
	for(j=NUM_ELEMENTS-1;;j--) if(p[i]<p[j]) break;

	swap = p[i];
	p[i] = p[j];
	p[j] = swap;

	for(j=i+1;j<NUM_ELEMENTS+i-j;j++) {
		swap = p[j];
		p[j] = p[NUM_ELEMENTS+i-j];
		p[NUM_ELEMENTS+i-j] = swap;
	}

	return true;
} */

int main (void) {
	wipe_file(MERGE_FILE);
	
	if ((!wipe_file(MERGE_FILE)) || (!begin())) {
		printf("FATAL ERROR AT INITIALIZE!\n");
		return 1;
	}

	int last_d = -1;
	int new_time;
	int old_time = -1;
	int time_diff;
	bool estimation_given = false;

	int * data = (int *)malloc(NUM_ELEMENTS * sizeof(int)); 
	int xx; for (xx=0;xx<=15;xx++) data[xx]=xx+1;

	//while (nextperm(data)) {
	while (true) {
		int i,j,swap;

		for (i=NUM_ELEMENTS-2; i>=0; i--) if(data[i]<data[i+1]) break;
		if(i<0) break; // return false;
		for(j=NUM_ELEMENTS-1;;j--) if(data[i]<data[j]) break;

		swap = data[i];
		data[i] = data[j];
		data[j] = swap;

		for(j=i+1;j<NUM_ELEMENTS+i-j;j++) {
			swap = data[j];
			data[j] = data[NUM_ELEMENTS+i-j];
			data[NUM_ELEMENTS+i-j] = swap;
		}

		// printf("Debug: %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n", data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7], data[8], data[9], data[10], data[11], data[12], data[13], data[14], data[15]);

		if (!estimation_given) {
			if (last_d != data[3]) {
				last_d = data[3];
				new_time = (int) time (NULL);
				if (old_time != -1) {
					time_diff = new_time - old_time;
					printf("Estimated time = %f days\n", (float)16*15*14*13*time_diff/60/60/24);
					estimation_given = true;
				}
				old_time = new_time;
			}
		}

		int sum = data[0]+data[1]+data[2]+data[3];
		if ((sum == data[4]+data[5]+data[6]+data[7]) && (sum == data[8]+data[9]+data[10]+data[11]) && (sum == data[12]+data[13]+data[14]+data[15]) &&
			(sum == data[0]+data[4]+data[8]+data[12]) && (sum == data[1]+data[5]+data[9]+data[13]) && (sum == data[2]+data[6]+data[10]+data[14]) && (sum == data[3]+data[7]+data[11]+data[15]) &&
			(sum == data[0]+data[5]+data[10]+data[15])) {
			if (!write_result(data)) {
				printf("FATAL ERROR AT WRITING RESULT!\n");
				return 1;
			}
		}
	}

	free(data);
	
	if (!finish()) {
		printf("FATAL ERROR AT FINALIZE!\n");
		return 1;
	}

	return 0;
}
